//sio.c
#include "sio.h"

#define CCLK          (7500000L)                                            //CCLK (Hz)
#define CGBGR         (1)                                                   //clock gear
#define CLKSIO        (CCLK/CGBGR)                                          //frequency CLKSIO (Hz)
#define BAUDRATE      (9600)                                                //baud rate of SIO (baud)
#define VALUE_OF_SIO  ((256 * (16 * BAUDRATE) - CLKSIO) / (16 * BAUDRATE))  //value of SIOBT register

void Delayf (unsigned long a) { while (--a!=0); }

void InitSIO()
{
    SIOBCN = 0x00;   //stop baud rate timer
    SIOSTA = 0x37;   //clear SIOSTA
    SIOCON = 0x00;   //clear SIOCON
    SIOBT  = 0x00;   //clear SIOBT
    SIOTCN = 0x00;   //clear SIOTCN

    SIOBT = VALUE_OF_SIO;
    SIOCON_bit.LN   = 0x0;  //8bit
    SIOCON_bit.PEN  = 0x0;  //none parity
    SIOCON_bit.TSTB = 0x1;  //1 stop bit

    GPCTL_bit.GPCTL1 = 1;   //set second function of port B.

    CGBCNT0 = 0x003c;
    CGBCNT0 = 0x0000;
    SIOBCN = 0x0010;

    SIOBUF = 0x0;
}

void sioWriteChar(unsigned char data)
{
  //while(SIOSTA_bit.TRIRQ != 1);
  SIOSTA_bit.TRIRQ = 0;
  SIOBUF = data;
}

unsigned char sioReadChar(void)
{
  while(SIOSTA_bit.RVIRQ != 1);
  SIOSTA_bit.RVIRQ = 0;
  return SIOBUF;
}

unsigned char sioReadChar_nontop(void)
{
  if(SIOSTA_bit.RVIRQ == 1)
  {
    SIOSTA_bit.RVIRQ = 0;
    return SIOBUF;
  }
  else return 0;
}

